#ifndef _CUBE_H
#define _CUBE_H

#include <stdint.h>
#include "common.h"
#include "uip/uip.h"

/* TCP/IP-Port */
#define CUBE_PORT 12345

/* Cube-Dimension */
#define CUBE_X 3
#define CUBE_Y 3
#define CUBE_Z 3
#define CUBE_XYZ (CUBE_X * CUBE_Y * CUBE_Z)

/* Befehlswoerter */
#define CMD_SET_LED     "SET_LED"
#define CMD_GET_XYZ     "GET_XYZ"
#define CMD_VERSION     "VERSION"
#define CMD_SET_PRELOAD "SET_PRELOAD"

/* Zeitpunkt der Uebersetzung (wird im Makefile gesetzt) */
#ifndef BUILD_DATE
#define BUILD_DATE "unknown\n"
#endif
static const char build_date[] = BUILD_DATE;

/* Antwort auf Befehl GET_XYZ */
#define TOSTR(val) STR(val)
#define STR(val) #val
#define OUT_SET_XYZ "set_xyz " TOSTR(CUBE_X) " " TOSTR(CUBE_Y) " " TOSTR(CUBE_Z) "\n"
static const char out_set_xyz[] = OUT_SET_XYZ;

/* Antwort auf Befehle SET_LED */
#define OUT_UPDATE_OK "update_ok\n"
static const char out_update_ok[] = OUT_UPDATE_OK;


/* Prototypen */
void SplitCmdArg(char * line, char ** cmd, char ** args);
void cube_init(void);
void cube_main(void);

/* Typ-Definitionen */
struct cube_cmd_state {
	enum {CMD_SET_LED_RECEIVE, NEW_CMD} state;
	uint16_t  arg_pos;		/* naechste zu uebernehmende Position bei set_led */
	char     *textptr;
	uint16_t  textlen;
};

#endif
